{
 "cells": [
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Stacks and Queues"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {},
   "outputs": [],
   "source": [
    "class Node:\n",
    "    def __init__(self, value, next = None):\n",
    "         self.val = value\n",
    "         self.next = next\n",
    "\n",
    "class stack: \n",
    "    def __init__(self):\n",
    "        self.head = None\n",
    "        self.length = 0\n",
    "    \n",
    "    def push(self, value):\n",
    "        self.length += 1\n",
    "        newNode = Node(value)\n",
    "        newNode.next = self.head\n",
    "        self.head = newNode\n",
    "    \n",
    "    def __len__(self):\n",
    "        return self.length    \n",
    "    \n",
    "    def top(self):\n",
    "        if self.length > 0:\n",
    "            return self.head.val\n",
    "        return None\n",
    "    \n",
    "    def pop(self):\n",
    "        if (self.length > 0):\n",
    "            self.length -= 1\n",
    "            popped = self.head\n",
    "            self.head = self.head.next\n",
    "            return popped.val\n",
    "        return None\n",
    "    \n",
    "    # Added to make your print easier\n",
    "    def __str__(self):\n",
    "        if self.length == 0:\n",
    "            return \"[]\"\n",
    "        \n",
    "        traversalNode = self.head\n",
    "        out = \"[\"\n",
    "        while (traversalNode != None):\n",
    "            out += str(traversalNode.val) + \", \"\n",
    "            traversalNode = traversalNode.next\n",
    "        out = out[:-2]\n",
    "        out += \"]\"\n",
    "        return out\n",
    "\n",
    "    def empty(self):\n",
    "        return self.length == 0\n"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {},
   "outputs": [],
   "source": [
    "def reverse(inList):\n",
    "    s = stack()\n",
    "    for v in inList:\n",
    "        s.push(v)\n",
    "    \n",
    "    out = []\n",
    "    while not s.empty():\n",
    "        out.append(s.pop())\n",
    "    return out\n",
    "\n",
    "print(reverse([1,2,3]))\n",
    "\n",
    "print(reverse([4,1,2,3,5,7,1,2]))"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "**On your own:** Try following how the stack changes by hand and check your work by running the following code!"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {},
   "outputs": [],
   "source": [
    "s = stack()\n",
    "\n",
    "print(s.empty())\n",
    "\n",
    "for i in range(0, 10, 2):\n",
    "    s.push(i)\n",
    "\n",
    "print(s)\n",
    "\n",
    "x = s.pop()\n",
    "print(x, s)\n",
    "\n",
    "print(len(s))\n",
    "\n",
    "print(s.top())\n",
    "s.pop()\n",
    "print(s.top())\n",
    "\n",
    "print(s.empty())"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "**The Call Stack** When your computer juggles processes either in code or in your OS, its probably keeping track of things with a call stack!"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {},
   "outputs": [],
   "source": [
    "def Happy():\n",
    "    print(\"Calling Happy!\")\n",
    "    return \"Happy\"\n",
    "\n",
    "def Little():\n",
    "    print(\"Calling Little!\")\n",
    "    return \"Little\"\n",
    "\n",
    "def Trees():\n",
    "    print(\"Calling Trees!\")\n",
    "    return \"Trees\"\n",
    "\n",
    "def LittleTrees():\n",
    "    print(\"Calling LittleTrees!\")\n",
    "    return Little() + Trees()\n",
    "\n",
    "def BobRoss():\n",
    "    print(\"Calling BobRoss!\")\n",
    "    return Happy() + LittleTrees()\n",
    "\n",
    "print(BobRoss())\n"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {},
   "outputs": [],
   "source": [
    "class Node:\n",
    "    def __init__(self, value, next = None):\n",
    "         self.val = value\n",
    "         self.next = next\n",
    "\n",
    "class queue:\n",
    "    def __init__(self):\n",
    "        self.length = 0\n",
    "        self.head = None\n",
    "        self.tail = None\n",
    "    \n",
    "    def enqueue(self, value):\n",
    "        self.length += 1\n",
    "        item = Node(value)\n",
    "        if self.head == None:\n",
    "            self.head = item\n",
    "            self.tail = item\n",
    "        else:\n",
    "            self.tail.next = item\n",
    "            self.tail = self.tail.next\n",
    "            \n",
    "    def dequeue(self):\n",
    "        if self.length > 0:\n",
    "            self.length -= 1\n",
    "            item = self.head\n",
    "            self.head = item.next\n",
    "\n",
    "            if self.head == None:\n",
    "                self.tail = None\n",
    "\n",
    "        return None\n",
    "\n",
    "    def front(self):\n",
    "        if self.length > 0:\n",
    "            return self.head.val\n",
    "        return None\n",
    "    \n",
    "    def __str__(self):\n",
    "        if self.length == 0:\n",
    "            return \"[]\"\n",
    "        \n",
    "        traversalNode = self.head\n",
    "        out = \"[\"\n",
    "        while (traversalNode != None):\n",
    "            out += str(traversalNode.val) + \", \"\n",
    "            traversalNode = traversalNode.next\n",
    "        out = out[:-2]\n",
    "        out += \"]\"\n",
    "        return out\n",
    "\n",
    "    def __len__(self):\n",
    "        return self.length\n",
    "\n",
    "    def empty(self):\n",
    "        return self.length == 0\n",
    "\n"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {},
   "outputs": [],
   "source": [
    "q = queue()\n",
    "\n",
    "print(q.empty())\n",
    "\n",
    "for i in range(0,20, 2):\n",
    "    q.enqueue(i)\n",
    "print(q)\n",
    "\n",
    "x = q.dequeue()\n",
    "print(x, q)\n",
    "\n",
    "print(len(q))\n",
    "\n",
    "print(q.front())\n",
    "q.dequeue()\n",
    "print(q.front())\n",
    "\n",
    "print(q.empty())"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## 2D Lists"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Write a Python function that takes three lists as input and makes a 2D list containing them."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 11,
   "metadata": {},
   "outputs": [],
   "source": [
    "def mergeLists(l1, l2, l3):\n",
    "    x = [1, 2, 3]\n",
    "    return [l1, l2, l3]\n",
    "    # None of the bottom will run (but its equivalent)\n",
    "    # Exercise 1\n",
    "    newList = []\n",
    "    newList.append(l1)\n",
    "    newList.append(l2)\n",
    "    newList.append(l3)\n",
    "    return newList"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 12,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "[[0, 1, 2], [3, 4, 5], ['A', 'B', 'C']]\n"
     ]
    }
   ],
   "source": [
    "x = mergeLists([0, 1, 2], [3, 4, 5], [\"A\", \"B\",\"C\"])\n",
    "print(x)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "**Programming Practice:** Write a Python function that takes as input a 2D list and searches the list for a specific value"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 19,
   "metadata": {},
   "outputs": [],
   "source": [
    "def search2D(l, val):\n",
    "    # Lets loop through each row\n",
    "    for row in l:\n",
    "        #print(row)\n",
    "        if val in row: # this will look at the top row only\n",
    "            return True\n",
    "        #return False # and immediately return\n",
    "    return False #once I reach this line, I have checked every row!\n",
    "\n",
    "    # This is just an alternate way of looping:\n",
    "    for i in range(len(l)):\n",
    "        print(l[i])\n",
    "    \n",
    "    \n",
    "    # Exercise 2\n",
    "    # dont do this:\n",
    "    return val in l # This will look for 4 against [0, 1, 2], [3, 4, 5], ..."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 20,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "True\n",
      "True\n",
      "True\n"
     ]
    }
   ],
   "source": [
    "print(search2D(x, 4))\n",
    "print(search2D(x, 'A'))\n",
    "\n",
    "y = [ [1], [2, 3], [4, 5, 6]]\n",
    "print(search2D(y, 5))"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {},
   "outputs": [],
   "source": [
    "outerList = []\n",
    "\n",
    "for i in range(5):\n",
    "    innerList = []\n",
    "\n",
    "    for j in range(5):\n",
    "        innerList.append(i+j)\n",
    "\n",
    "    outerList.append(innerList)\n",
    "\n",
    "print(outerList)\n",
    "\n",
    "print(outerList[3][1])"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {},
   "outputs": [],
   "source": [
    "# Tip: If you get confused about 2D matrix indexing, make a quick example."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 23,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "[[0, 1, 2], [3, 4, 5], [6, 7, 8]]\n",
      "8\n",
      "7\n",
      "5\n",
      "[[0 1 2]\n",
      " [3 4 5]\n",
      " [6 7 8]]\n"
     ]
    }
   ],
   "source": [
    "count = 0\n",
    "out = []\n",
    "# create some simple matrix\n",
    "for i in range(3):\n",
    "    tmp = []\n",
    "    for j in range(3):\n",
    "        tmp.append(count)\n",
    "        count+=1\n",
    "    out.append(tmp)\n",
    "\n",
    "print(out)\n",
    "print(out[2][2])\n",
    "print(out[2][1])\n",
    "print(out[1][2])\n",
    "\n",
    "# What is this package? Lets find out!\n",
    "import numpy as np\n",
    "x = np.arange(9).reshape(3, 3)\n",
    "print(x)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "**NumPy** is a very useful Python module for handling 2D lists."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 29,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "[1 2 3 4 5 6]\n",
      "(6,)\n",
      "[1 2 3 4 5 6]\n",
      "(3, 2)\n",
      "[[ 0  1  2  3  4]\n",
      " [ 5  6  7  8  9]\n",
      " [10 11 12 13 14]]\n",
      "[[0. 0. 0. 0. 0.]\n",
      " [0. 0. 0. 0. 0.]]\n"
     ]
    }
   ],
   "source": [
    "import numpy as np\n",
    "\n",
    "# Convert list to np list\n",
    "nl = np.array([1, 2, 3, 4, 5, 6])\n",
    "print(nl) #[1 2 3 4 5 6]\n",
    "\n",
    "# Print the shape of a list\n",
    "print(nl.shape) #(6, )\n",
    "\n",
    "# Modify list shape\n",
    "nl2 = nl.reshape(3, 2) # row , col\n",
    "\n",
    "\n",
    "print(nl)\n",
    "print(nl2.shape)\n",
    "\n",
    "# Create a new list\n",
    "nl3 = np.arange(15).reshape(3, 5) # I need 15 items EXACTLY\n",
    "nl4 = np.zeros((2, 5))\n",
    "\n",
    "print(nl3)\n",
    "print(nl4)\n"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 31,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "[[0 1]\n",
      " [2 3]]\n",
      "[[0 2]\n",
      " [4 6]]\n",
      "[[0, 1], [2, 3], [0, 1], [2, 3]]\n"
     ]
    }
   ],
   "source": [
    "nl = np.arange(4).reshape(2, 2)\n",
    "\n",
    "# 0 1\n",
    "# 2 3\n",
    "print(nl)\n",
    "\n",
    "nl2 = nl * 2\n",
    "\n",
    "print(nl2)\n",
    "\n",
    "# builtin\n",
    "x = [[0, 1], [2, 3]]\n",
    "print(x * 2)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {},
   "outputs": [],
   "source": [
    "m1 = np.arange(9).reshape(3,3)\n",
    "print(m1)\n",
    "m2 = np.arange(9, 0, -1).reshape(3,3)\n",
    "print(m2)\n",
    "m1+m2"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {},
   "outputs": [],
   "source": [
    "nl = np.arange(4).reshape(2, 2)\n",
    "nl2 = nl * 2\n",
    "\n",
    "# Matrix multiplication\n",
    "# 0*0+1*4     0*0+1*6\n",
    "# 2*0+3*4     2*2+3*6\n",
    "print(nl.dot(nl2))\n",
    "\n",
    "# Unique items\n",
    "x = np.array([1, 1, 1, 2, 3, 4, 4, 5, 5, 6])\n",
    "print(np.unique(x))\n"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "What happens when we run the following code? Why?"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {},
   "outputs": [],
   "source": [
    "orig = [ [1,2,3], [4, 5, 6]]\n",
    "\n",
    "copy = orig[:]\n",
    "\n",
    "orig[1][1]=9\n",
    "copy[0][2]=7\n",
    "\n",
    "print(orig)\n",
    "print(copy)\n"
   ]
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "Python 3 (ipykernel)",
   "language": "python",
   "name": "python3"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 3
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython3",
   "version": "3.11.0"
  },
  "vscode": {
   "interpreter": {
    "hash": "1a1af0ee75eeea9e2e1ee996c87e7a2b11a0bebd85af04bb136d915cefc0abce"
   }
  }
 },
 "nbformat": 4,
 "nbformat_minor": 4
}
